/***************************************************************************
 **
 ** (c) 1993,1994,1995 by Marc van Shaney , aka Kaya Memisoglu
 **
 ** This Source-Code was written by and is copyrighted by Kaya Memisoglu
 ** You may use the whole code or only parts of it in your own programs
 ** whether they are commercial or not. BUT you must give credits for these
 ** parts to me (Kaya Memisoglu  or  Marc van Shaney).
 ** I am not responsible for any damage or loss caused by this program, so
 ** if you success in erasing your harddisk with this code, then it is your
 ** own fault and you should not claim me to be responsible...
 ** I would be very pleased if you also sent me a postcard or even a letter
 ** if you can use this code. My address:
 **
 **        Kaya Memisoglu
 **        Reichenberger Ring 50
 **        63512 Hainburg
 **        Germany
 **
 ** You can also leave a message for Marc van Shaney on the Nirvana BBS:
 **
 **              Nirvana BBS     ++49-(0)6245-3056      Sysop:Raytrayza
 **
 **
 **/


#ifndef __FRAME_H
#define __FRAME_H

#ifndef BITMAP_TYPE
#define BITMAP_TYPE
typedef struct {
		int Width;
		int Height;
		int Bits_per_Pixel;
		int Bytes_per_Line;
		char Enhance[8];
		char Data[];
	       } Bitmap;
#endif

#ifndef IFS_TYPE
#define IFS_TYPE
typedef struct {
		int Count;
		int Reserved[7];
		long Data[];
	       } IFS;
#endif


extern void Clear_Frame (char far *,char);
extern void FDraw_Text (char far *,int,int,char far *,char);
extern void FDraw_Scroller (char far *,int,char far *,char,int);
extern void FGet_Image (char far *,int,int,int,int,Bitmap *);
extern void FPut_Image (char far *,int,int,Bitmap *);
extern void FPut_Sprite (char far *,int,int,Bitmap *);
extern void FZoom_Sprite (char far *,int,int,int,int,Bitmap *);
extern void FZoom_Image (char far *,int,int,int,int,Bitmap *);
extern void FDraw_Oscilloscope (char far *,int,int,int,char far *,char);
extern void Copy_Frame (char far*,char far *);
extern void FMove_Fire(Bitmap *);
extern void FWrite_in_Fire(Bitmap *,int,int,char *,char);


extern void Calc_Mandel (Bitmap *,long,long,long,long);
extern void Prepare_IFS (IFS *);
extern void Tween_IFS(IFS *,IFS *,IFS *,int);
extern void FDraw_VLens (char *,int,int);
extern void FDraw_IFS (char *,IFS *,int);
extern void FDraw_Texture(char *,int incx,int incy,char *);
extern void FZoom_Texture(char far *,int,int,int,int,char *);
extern void FMap_Image(char far *,long,Bitmap *);
extern void FDraw_Bob(char *,int,int,Bitmap *);
extern void FDelete_Bob(char *,int,int,Bitmap *);
extern void FStretch_Image(char *,int,int,int,Bitmap *);
extern void FMagnify_Frame(char *,int,char *);
extern void FWobble_Texture(char *,int,int,char *);
extern void FDither_Frame(char *,int);
extern void FDraw_Moire(char *,long);
extern void FDraw_Plasma(char *,int,int,int,int);

#endif